package com.example.demo;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

public abstract class People<PersonType extends Person> implements Iterable<PersonType>{
    List<PersonType> personList = new ArrayList<>();

    public People(List<PersonType> personList) {
        this.personList = personList;
    }
    public People(PersonType ... arg){
        for (PersonType person : arg){
            personList.add(person);
        }
    }
    public void add(PersonType person){
        personList.add(person);
    }
    public void remove(PersonType person){
        personList.remove(person);
    }
    public int size(){
        return personList.size();
    }
    public void clear(){
        for (PersonType person: personList){
            remove(person);
        }
    }
    public void addAll(Iterable<PersonType> iterable){
        iterable.forEach(personType -> personList.add(personType));
    }
    public PersonType findById(long id){
        for(PersonType person: personList){
            if (person.getId()==id){
                return person;
            }
        }
        return null;
    }

    public List<PersonType> findAll(){
        return personList;
    }

}
